--- toast-linux	2004/04/14 22:28:34	1.20
+++ toast-linux	2004/04/15 06:20:38	1.21
@@ -840,28 +840,13 @@
 mount -a
 ifconfig lo 127.0.0.1
 hostname localhost
-autoinstall
+run
 
---- FILE root/sbin/autoinstall ---
-#!/bin/sh -e
-echo "Configuring network."
-network
-echo ""
-echo "Examining disks:"
-partition > /tmp/partition.tmp
-grep '^# ' /tmp/partition.tmp
-echo "Preparing to write new disk partitions as described above."
-echo "Press any key to abort."
-timeout 20
-sh -ex /tmp/partition.tmp
-rm /tmp/partition.tmp
-swap
-migrate
-toaststrap
-
 --- FILE root/sbin/network ---
 #!/bin/sh
 
+echo "Configuring network."
+
 IF="`echo \"$DNS\" | sed -e 's/[^a-z0-9]/ /g; s/^  *//; s/  *$//'`"
 IP="`echo \"$IP\" | sed -e 's/[^0-9\.]/ /g; s/^  *//; s/  *$//'`"
 NM="`echo \"$NM\" | sed -e 's/[^0-9\.]/ /g; s/^  *//; s/  *$//'`"
@@ -988,7 +973,71 @@
 echo -ne '\r          \r'
 [ -z "$key" ]
 
---- FILE root/sbin/migrate ---
+--- FILE root/sbin/task ---
+#!/bin/sh
+
+cost="$1"
+name="$2"
+shift 2
+
+dir="/var/run/tasks"
+tfile="$dir/total"
+cfile="$dir/current"
+lfile="$dir/list"
+ndir="$dir/names"
+ddir="$dir/done"
+
+total=0
+[ -r "$tfile" ] && read total < "$tfile"
+
+if [ -n "$TASK_INIT" ]; then
+  nfile="$ndir/$name"
+  [ -r "$nfile" ] && exit 0
+  mkdir -p "$dir" "$ndir" "$ddir"
+  : > "$nfile"
+  let total="$total+$cost"
+  echo "$total" > "$tfile"
+  echo "$name" >> "$lfile"
+  echo "0" > "$cfile"
+  exit 0
+fi
+
+dfile="$ddir/$name"
+[ -r "$dfile" ] && exit 0
+
+firstline=3
+lastline=25
+echo -ne '\33[H'
+line=""
+while read i; do
+  line="$line $i"
+  if echo "$line" | egrep -q '.{79}'; then
+    let firstline="1+$firstline"
+    echo -e '\33[K'
+    line=" $i"
+  fi
+  echo -en '\33[0;44m '
+  [ "$name" = "$i" ] && echo -en '\33[0;1m'
+  echo -n "$i"
+done < "$lfile"
+
+echo -e '\33[K'
+echo -ne '\33[1;33;43m'
+read current < "$cfile"
+let bar="$current*80/$total"
+while [ "$bar" -gt 0 ]; do
+  echo -ne '\16a\17'
+  let bar="$bar-1"
+done
+echo -ne '\33[0;41m\33[K\33[m\33['"$firstline;$lastline"'r\33['"$lastline"'H'
+
+"$@" || exit $?
+
+: > "$dfile"
+let current="$current+$cost"
+echo "$current" > $cfile
+
+--- FILE root/sbin/setup ---
 #!/bin/sh -e
 
 target="/mnt/root"
@@ -1100,6 +1149,20 @@
 --- FILE root/sbin/partition ---
 #!/bin/sh
 
+if [ "$*" != "foo" ]; then
+  set -e
+  echo ""
+  echo "Examining disks:"
+  $0 foo > /tmp/partition.tmp
+  grep '^# ' /tmp/partition.tmp
+  echo "Preparing to write new disk partitions as described above."
+  echo "Press any key to abort."
+  timeout 20
+  sh -ex /tmp/partition.tmp
+  rm /tmp/partition.tmp
+  exit 0
+fi
+
 # Environment variables:
 # DISKS
 # DESTROY
@@ -1575,13 +1638,24 @@
   fi
 done
 
---- FILE root/sbin/toaststrap ---
+--- FILE root/sbin/utoastdeb ---
+#!/bin/sh
+exec utoast "deb-$1" "$3" "http://http.us.debian.org/debian/pool/main/$4/$2_$3_i386.deb"
+
+--- FILE root/sbin/run ---
 #!/bin/sh -e
 
 # XXX use local squid proxy to reduce bandwidth consumption for testing:
 export http_proxy=http://cli-03:3128/
 export ftp_proxy=http://cli-03:3128/
 
+[ -z "$TASK_INIT" ] && TASK_INIT=1 $0
+
+task 1 network network
+task 1 partition partition
+task 1 swap swap
+task 1 setup setup
+
 # Step 1: Download the minimum required binary packages.
 # These are all stolen from Debian testing.
 # I'm including a perl binary here because perl refuses to build without comm,
@@ -1590,25 +1664,21 @@
 # Including bash because hardly anything will build with busybox ash alone.
 # Including ncurses only because the bash binary requires it.
 
-utoastdeb()
-{
-  utoast "deb-$1" "$3" "http://http.us.debian.org/debian/pool/main/$4/$2_$3_i386.deb"
-}
-utoastdeb glibc libc6 2.3.2.ds1-11 g/glibc
-utoastdeb headers libc6-dev 2.3.2.ds1-11 g/glibc
-utoastdeb linux linux-kernel-headers 2.5.999-test7-bk-15 l/linux-kernel-headers
-utoastdeb binutils binutils 2.14.90.0.7-6 b/binutils
-utoastdeb gcc gcc-3.3 3.3.3-6 g/gcc-3.3
-utoastdeb cpp cpp-3.3 3.3.3-6 g/gcc-3.3
-utoastdeb perl perl-base 5.8.3-3 p/perl
-utoastdeb ncurses libncurses5 5.4-3 n/ncurses # required by bash
-utoastdeb bash bash 2.05b-14 b/bash
+task 1 glibc0 utoastdeb glibc libc6 2.3.2.ds1-11 g/glibc
+task 1 headers utoastdeb headers libc6-dev 2.3.2.ds1-11 g/glibc
+task 1 kheaders utoastdeb kheaders linux-kernel-headers 2.5.999-test7-bk-15 l/linux-kernel-headers
+task 1 binutils0 utoastdeb binutils binutils 2.14.90.0.7-6 b/binutils
+task 1 gcc0 utoastdeb gcc gcc-3.3 3.3.3-6 g/gcc-3.3
+task 1 cpp utoastdeb cpp cpp-3.3 3.3.3-6 g/gcc-3.3
+task 1 perl0 utoastdeb perl perl-base 5.8.3-3 p/perl
+task 1 ncurses0 utoastdeb ncurses libncurses5 5.4-3 n/ncurses # required by bash
+task 1 bash0 utoastdeb bash bash 2.05b-14 b/bash
 
 # Step 2: Install toast, so we can use it to install everything else.
 # Note that utoast currently needs make in order to install toast.
 
-utoast make 3.80 http://ftp.gnu.org/gnu/make/make-3.80.tar.bz2
-utoast toast 1.320 http://toastball.net/toast/toast-1.320.tar.gz
+task 1 make1 utoast make 3.80 http://ftp.gnu.org/gnu/make/make-3.80.tar.bz2
+task 1 toast1 utoast toast 1.320 http://toastball.net/toast/toast-1.320.tar.gz
 
 # Step 3: Replace all binary packages from step 1 with source packages.
 # Everything compiled from source prior to this point will need to be rebuilt
@@ -1619,13 +1689,13 @@
 # Note that we install kernel headers from 2.4 with glibc because some programs
 # (notably LILO) won't compile against the headers in 2.6.  What a mess.
 
-toast arm http://ftp.gnu.org/gnu/gawk/gawk-3.1.3.tar.bz2
-toast arm http://ftp.gnu.org/gnu/coreutils/coreutils-5.0.tar.bz2
-toast arm http://ftp.gnu.org/gnu/gcc/gcc-3.3.2/gcc-3.3.2.tar.bz2
-toast remove deb-gcc deb-cpp
-toast arm http://www.cpan.org/src/5.0/perl-5.8.2.tar.gz
-toast remove deb-perl
-toast arm glibc/2.3.2: [ http://ftp.gnu.org/gnu/glibc/glibc-2.3.2.tar.bz2 http://ftp.gnu.org/gnu/glibc/glibc-linuxthreads-2.3.2.tar.bz2 http://kernel.org/pub/linux/kernel/v2.4/linux-2.4.25.tar.bz2 http://toastball.net/toast-linux-tmp/glibc-2.3.2-gcc-2.3.x.patch ]
+task 1 gawk1 toast arm http://ftp.gnu.org/gnu/gawk/gawk-3.1.3.tar.bz2
+task 1 coreutils1 toast arm http://ftp.gnu.org/gnu/coreutils/coreutils-5.0.tar.bz2
+task 1 gcc1 toast arm http://ftp.gnu.org/gnu/gcc/gcc-3.3.2/gcc-3.3.2.tar.bz2
+task 1 clean1 toast remove deb-gcc deb-cpp
+task 1 perl1 toast arm http://www.cpan.org/src/5.0/perl-5.8.2.tar.gz
+task 1 clean2 toast remove deb-perl
+task 1 glibc1 toast arm glibc/2.3.2: [ http://ftp.gnu.org/gnu/glibc/glibc-2.3.2.tar.bz2 http://ftp.gnu.org/gnu/glibc/glibc-linuxthreads-2.3.2.tar.bz2 http://kernel.org/pub/linux/kernel/v2.4/linux-2.4.25.tar.bz2 http://toastball.net/toast-linux-tmp/glibc-2.3.2-gcc-2.3.x.patch ]
 # http://www.rocklinux.net/sources/package/base/glibc23/gcc33-hotfix.patch
 # http://www.pengutronix.de/software/ptxdist/patches-0.5.0/glibc-2.3.2/generic/generic-sscanf.diff
 # http://nl.lunar-linux.org/lunar/patches/glibc-2.3.2-newstyle.patch
@@ -1634,90 +1704,90 @@
 # http://www.muth.org/Robert/Patch/glibc-2.3.2.patch
 # http://mirror.gentoo.ru/pub/mirror/gentoo-portage/sys-libs/glibc/files/2.3.2/glibc-2.3.2-gcc33-sscanf.patch
 # http://sources.redhat.com/ml/bug-glibc/2003-10/msg00101/sscanf.c.diff
-toast remove deb-headers deb-linux
-toast arm http://ftp.gnu.org/gnu/binutils/binutils-2.14.tar.bz2
-toast remove deb-binutils
-toast arm http://ftp.gnu.org/gnu/bash/bash-2.05b.tar.gz
-toast rebuild glibc gcc binutils coreutils make gawk toast
-# Perl must be rebuilt in separate invocation of toast; otherwise toast will
-# continue running without knowing the correct location of perl:
-toast rebuild perl
-toast remove deb-ncurses deb-glibc deb-bash
+task 1 clean3 toast remove deb-headers deb-kheaders
+task 1 binutils1 toast arm http://ftp.gnu.org/gnu/binutils/binutils-2.14.tar.bz2
+task 1 clean4 toast remove deb-binutils
+task 1 bash1 toast arm http://ftp.gnu.org/gnu/bash/bash-2.05b.tar.gz
+task 1 glibc toast rebuild glibc
+task 1 gcc toast rebuild gcc
+task 1 binutils toast rebuild binutils
+task 1 coreutils toast rebuild coreutils
+task 1 make toast rebuild make
+task 1 gawk toast rebuild gawk
+task 1 toast toast rebuild toast
+task 1 perl toast rebuild perl
+task 1 clean4 toast remove deb-ncurses deb-glibc deb-bash
 
 # Step 4: Replace busybox with full GNU/Linux tools.
 
-toast arm http://ftp.gnu.org/gnu/sed/sed-4.0.9.tar.gz
-toast arm http://kernel.org/pub/linux/utils/util-linux/util-linux-2.11z.tar.bz2
-toast arm http://kernel.org/pub/linux/utils/kernel/module-init-tools/module-init-tools-3.0.tar.bz2
-toast arm http://ftp.gnu.org/gnu/ncurses/ncurses-5.4.tar.gz
-toast arm http://procps.sourceforge.net/procps-3.1.15.tar.gz
-toast arm ftp://alpha.gnu.org/gnu/tar/tar-1.13.25.tar.gz
-toast arm http://ftp.gnu.org/gnu/gzip/gzip-1.2.4a.tar.gz
-toast arm http://ftp.gnu.org/gnu/patch/patch-2.5.4.tar.gz
-toast arm [ http://ftp.gnu.org/gnu/findutils/findutils-4.1.tar.gz http://www.linuxfromscratch.org/findutils-4.1.patch ]
-toast arm http://ftp.gnu.org/gnu/grep/grep-2.5.tar.bz2
-toast arm ftp://ftp.cistron.nl/pub/people/miquels/sysvinit/sysvinit-2.85.tar.gz
-toast arm http://www.ibiblio.org/pub/Linux/system/hardware/hdparm-5.5.tar.gz
-toast arm http://ftp.gnu.org/gnu/inetutils/inetutils-1.4.2.tar.gz
-toast arm http://ftp.gnu.org/gnu/wget/wget-1.9.1.tar.gz
-toast arm http://udhcp.busybox.net/source/udhcp-0.9.8.tar.gz
-toast arm http://ftp.gnu.org/gnu/diffutils/diffutils-2.8.1.tar.gz
-toast arm ftp://ftp.vim.org/pub/vim/unix/vim-6.2.tar.bz2
-toast remove busybox
+task 1 sed toast arm http://ftp.gnu.org/gnu/sed/sed-4.0.9.tar.gz
+task 1 util-linux toast arm http://kernel.org/pub/linux/utils/util-linux/util-linux-2.11z.tar.bz2
+task 1 module-init-tools toast arm http://kernel.org/pub/linux/utils/kernel/module-init-tools/module-init-tools-3.0.tar.bz2
+task 1 ncurses toast arm http://ftp.gnu.org/gnu/ncurses/ncurses-5.4.tar.gz
+task 1 procps toast arm http://procps.sourceforge.net/procps-3.1.15.tar.gz
+task 1 tar toast arm ftp://alpha.gnu.org/gnu/tar/tar-1.13.25.tar.gz
+task 1 gzip toast arm http://ftp.gnu.org/gnu/gzip/gzip-1.2.4a.tar.gz
+task 1 patch toast arm http://ftp.gnu.org/gnu/patch/patch-2.5.4.tar.gz
+task 1 findutils toast arm [ http://ftp.gnu.org/gnu/findutils/findutils-4.1.tar.gz http://www.linuxfromscratch.org/findutils-4.1.patch ]
+task 1 grep toast arm http://ftp.gnu.org/gnu/grep/grep-2.5.tar.bz2
+task 1 sysvinit toast arm ftp://ftp.cistron.nl/pub/people/miquels/sysvinit/sysvinit-2.85.tar.gz
+task 1 hdparm toast arm http://www.ibiblio.org/pub/Linux/system/hardware/hdparm-5.5.tar.gz
+task 1 inetutils toast arm http://ftp.gnu.org/gnu/inetutils/inetutils-1.4.2.tar.gz
+task 1 wget toast arm http://ftp.gnu.org/gnu/wget/wget-1.9.1.tar.gz
+task 1 udhcp toast arm http://udhcp.busybox.net/source/udhcp-0.9.8.tar.gz
+task 1 diffutils toast arm http://ftp.gnu.org/gnu/diffutils/diffutils-2.8.1.tar.gz
+task 1 vim toast arm ftp://ftp.vim.org/pub/vim/unix/vim-6.2.tar.bz2
+task 1 clean5 toast remove busybox
 
 # Some of these packages can't be installed until busybox is gone because
 # they require the LD_PRELOAD hack in order to install correctly:
 
-toast arm http://mirrors.kernel.org/sources.redhat.com/bzip2/v102/bzip2-1.0.2.tar.gz
-toast arm http://www.infodrom.org/projects/sysklogd/download/sysklogd-1.4.1.tar.gz
-toast arm http://www.tazenda.demon.co.uk/phil/net-tools/net-tools-1.60.tar.bz2
+task 1 bzip2 toast arm http://mirrors.kernel.org/sources.redhat.com/bzip2/v102/bzip2-1.0.2.tar.gz
+task 1 sysklogd toast arm http://www.infodrom.org/projects/sysklogd/download/sysklogd-1.4.1.tar.gz
+task 1 net-tools toast arm http://www.tazenda.demon.co.uk/phil/net-tools/net-tools-1.60.tar.bz2
 
 # Step 5: Install what we will need in order to make the system usable.
 
-toast arm [ http://kernel.org/pub/linux/kernel/v2.6/linux-2.6.5.tar.bz2 http://toastball.net/toast-linux-tmp/linux-2.6.5-config.tar.gz ]
-toast arm ftp://ftp.sistina.com/pub/LVM2/device-mapper/device-mapper.1.00.07.tgz
-toast arm ftp://ftp.sistina.com/pub/LVM2/tools/LVM2.2.00.08.tgz
-toast arm http://www.cix.co.uk/~mayday/dev86/bin86-0.16.15.tar.gz
-toast arm http://unc.dl.sourceforge.net/sourceforge/nasm/nasm-0.98.38.tar.bz2
-toast arm lilo/22.5.8+devmapper: [ http://home.san.rr.com/johninsd/pub/linux/lilo/lilo-22.5.8.tar.gz http://www.saout.de/misc/lilo-22.5.8-devmapper.patch ]
-toast arm http://ftp.gnu.org/gnu/gettext/gettext-0.14.1.tar.gz
-toast arm http://unc.dl.sourceforge.net/sourceforge/e2fsprogs/e2fsprogs-1.34.tar.gz
-toast arm http://kernel.org/pub/linux/daemons/devfsd/devfsd-v1.3.25.tar.bz2
-toast arm genext2fs/1.3-4: [ http://http.us.debian.org/debian/pool/main/g/genext2fs/genext2fs_1.3.orig.tar.gz http://http.us.debian.org/debian/pool/main/g/genext2fs_1.3-4.diff.gz ]
-toast arm http://toastball.net/toast-linux-tmp/toastinit-1.3.tar.gz
-toast arm http://toastball.net/toast-linux-tmp/toastlogin-1.8.tar.gz
+task 1 linux toast arm [ http://kernel.org/pub/linux/kernel/v2.6/linux-2.6.5.tar.bz2 http://toastball.net/toast-linux-tmp/linux-2.6.5-config.tar.gz ]
+task 1 device-mapper toast arm ftp://ftp.sistina.com/pub/LVM2/device-mapper/device-mapper.1.00.07.tgz
+task 1 LVM2 toast arm ftp://ftp.sistina.com/pub/LVM2/tools/LVM2.2.00.08.tgz
+task 1 bin86 toast arm http://www.cix.co.uk/~mayday/dev86/bin86-0.16.15.tar.gz
+task 1 nasm toast arm http://unc.dl.sourceforge.net/sourceforge/nasm/nasm-0.98.38.tar.bz2
+task 1 lilo toast arm lilo/22.5.8+devmapper: [ http://home.san.rr.com/johninsd/pub/linux/lilo/lilo-22.5.8.tar.gz http://www.saout.de/misc/lilo-22.5.8-devmapper.patch ]
+task 1 gettext toast arm http://ftp.gnu.org/gnu/gettext/gettext-0.14.1.tar.gz
+task 1 e2fsprogs toast arm http://unc.dl.sourceforge.net/sourceforge/e2fsprogs/e2fsprogs-1.34.tar.gz
+task 1 devfsd toast arm http://kernel.org/pub/linux/daemons/devfsd/devfsd-v1.3.25.tar.bz2
+task 1 genext2fs toast arm genext2fs/1.3-4: [ http://http.us.debian.org/debian/pool/main/g/genext2fs/genext2fs_1.3.orig.tar.gz http://http.us.debian.org/debian/pool/main/g/genext2fs_1.3-4.diff.gz ]
+task 1 toastinit toast arm http://toastball.net/toast-linux-tmp/toastinit-1.3.tar.gz
+task 1 toastlogin toast arm http://toastball.net/toast-linux-tmp/toastlogin-1.8.tar.gz
 
 # Step 6: Bring the new system roughly up to par with Linux From Scratch.
 
-toast arm http://kernel.org/pub/linux/docs/manpages/man-pages-1.65.tar.bz2
-toast arm http://www.libpng.org/pub/png/src/zlib-1.2.1.tar.gz
-toast arm http://ftp.gnu.org/gnu/m4/m4-1.4.tar.gz
-toast arm http://ftp.gnu.org/gnu/bison/bison-1.875.tar.bz2
-toast arm http://www.greenwoodsoftware.com/less/less-381.tar.gz
-toast arm http://ftp.gnu.org/gnu/groff/groff-1.19.tar.gz
-toast arm http://unc.dl.sourceforge.net/sourceforge/lex/flex-2.5.31.tar.bz2
-toast arm http://ftp.gnu.org/gnu/texinfo/texinfo-4.6.tar.gz
-toast arm http://ftp.gnu.org/gnu/autoconf/autoconf-2.59.tar.gz
-toast arm http://ftp.gnu.org/gnu/automake/automake-1.8.2.tar.gz
-toast arm ftp://ftp.astron.com/pub/file/file-4.07.tar.gz
-toast arm http://ftp.gnu.org/gnu/libtool/libtool-1.5.2.tar.gz
-toast arm http://ftp.gnu.org/gnu/ed/ed-0.2.tar.gz
-toast arm ftp://ftp.win.tue.nl/pub/linux-local/utils/kbd/kbd-1.12.tar.gz
-toast arm http://kernel.org/pub/linux/utils/man/man-1.5m2.tar.bz2
-toast arm http://www.sethwklein.net/projects/iana-etc/downloads/iana-etc-0.99.tar.bz2
+task 1 man-pages toast arm http://kernel.org/pub/linux/docs/manpages/man-pages-1.65.tar.bz2
+task 1 zlib toast arm http://www.libpng.org/pub/png/src/zlib-1.2.1.tar.gz
+task 1 m4 toast arm http://ftp.gnu.org/gnu/m4/m4-1.4.tar.gz
+task 1 bison toast arm http://ftp.gnu.org/gnu/bison/bison-1.875.tar.bz2
+task 1 less toast arm http://www.greenwoodsoftware.com/less/less-381.tar.gz
+task 1 groff toast arm http://ftp.gnu.org/gnu/groff/groff-1.19.tar.gz
+task 1 flex toast arm http://unc.dl.sourceforge.net/sourceforge/lex/flex-2.5.31.tar.bz2
+task 1 texinfo toast arm http://ftp.gnu.org/gnu/texinfo/texinfo-4.6.tar.gz
+task 1 autoconf toast arm http://ftp.gnu.org/gnu/autoconf/autoconf-2.59.tar.gz
+task 1 automake toast arm http://ftp.gnu.org/gnu/automake/automake-1.8.2.tar.gz
+task 1 file toast arm ftp://ftp.astron.com/pub/file/file-4.07.tar.gz
+task 1 libtool toast arm http://ftp.gnu.org/gnu/libtool/libtool-1.5.2.tar.gz
+task 1 ed toast arm http://ftp.gnu.org/gnu/ed/ed-0.2.tar.gz
+task 1 kbd toast arm ftp://ftp.win.tue.nl/pub/linux-local/utils/kbd/kbd-1.12.tar.gz
+task 1 man toast arm http://kernel.org/pub/linux/utils/man/man-1.5m2.tar.bz2
+task 1 iana-etc toast arm http://www.sethwklein.net/projects/iana-etc/downloads/iana-etc-0.99.tar.bz2
 
 # Step 7: Install other essential packages.
 
-toast arm http://archive.progeny.com/zsh/zsh-4.2.0.tar.bz2
-toast arm http://ftp.gnu.org/gnu/readline/readline-4.3.tar.gz
-toast arm http://ftp.gnu.org/gnu/parted/parted-1.6.6.tar.gz
+task 1 zsh toast arm http://archive.progeny.com/zsh/zsh-4.2.0.tar.bz2
+task 1 readline toast arm http://ftp.gnu.org/gnu/readline/readline-4.3.tar.gz
+task 1 parted toast arm http://ftp.gnu.org/gnu/parted/parted-1.6.6.tar.gz
 
-# Step 8: Remove the last traces of the installer, including this script.
+task 1 runlilo lilo
 
-toast disarm scripts
-
-lilo
-
 # TODO:
 # openssh
 # reorder and/or rebuild packages to take full advantage of optional libraries
@@ -1760,6 +1830,7 @@
 # CONFIG_BSD_PROCESS_ACCT is not set
 CONFIG_SYSCTL=y
 CONFIG_LOG_BUF_SHIFT=14
+CONFIG_HOTPLUG=y
 CONFIG_IKCONFIG=y
 CONFIG_IKCONFIG_PROC=y
 CONFIG_EMBEDDED=y
@@ -1780,6 +1851,7 @@
 # Processor type and features
 #
 CONFIG_X86_PC=y
+# CONFIG_X86_ELAN is not set
 # CONFIG_X86_VOYAGER is not set
 # CONFIG_X86_NUMAQ is not set
 # CONFIG_X86_SUMMIT is not set
@@ -1795,11 +1867,11 @@
 # CONFIG_M686 is not set
 # CONFIG_MPENTIUMII is not set
 # CONFIG_MPENTIUMIII is not set
+# CONFIG_MPENTIUMM is not set
 # CONFIG_MPENTIUM4 is not set
 # CONFIG_MK6 is not set
 # CONFIG_MK7 is not set
 # CONFIG_MK8 is not set
-# CONFIG_MELAN is not set
 # CONFIG_MCRUSOE is not set
 # CONFIG_MWINCHIPC6 is not set
 # CONFIG_MWINCHIP2 is not set
@@ -1822,12 +1894,17 @@
 # CONFIG_MICROCODE is not set
 # CONFIG_X86_MSR is not set
 # CONFIG_X86_CPUID is not set
+
+#
+# Firmware Drivers
+#
 # CONFIG_EDD is not set
 CONFIG_NOHIGHMEM=y
 # CONFIG_HIGHMEM4G is not set
 # CONFIG_HIGHMEM64G is not set
 # CONFIG_MATH_EMULATION is not set
 # CONFIG_MTRR is not set
+# CONFIG_REGPARM is not set
 
 #
 # Power management options (ACPI, APM)
@@ -1838,6 +1915,7 @@
 # ACPI (Advanced Configuration and Power Interface) Support
 #
 # CONFIG_ACPI is not set
+CONFIG_ACPI_BOOT=y
 
 #
 # CPU Frequency scaling
@@ -1849,17 +1927,18 @@
 #
 CONFIG_PCI=y
 # CONFIG_PCI_GOBIOS is not set
+# CONFIG_PCI_GOMMCONFIG is not set
 # CONFIG_PCI_GODIRECT is not set
 CONFIG_PCI_GOANY=y
 CONFIG_PCI_BIOS=y
 CONFIG_PCI_DIRECT=y
+CONFIG_PCI_MMCONFIG=y
 # CONFIG_PCI_LEGACY_PROC is not set
 # CONFIG_PCI_NAMES is not set
 CONFIG_ISA=y
 # CONFIG_EISA is not set
 # CONFIG_MCA is not set
 # CONFIG_SCx200 is not set
-CONFIG_HOTPLUG=y
 
 #
 # PCMCIA/CardBus support
@@ -1922,6 +2001,7 @@
 CONFIG_BLK_DEV_LOOP=y
 # CONFIG_BLK_DEV_CRYPTOLOOP is not set
 # CONFIG_BLK_DEV_NBD is not set
+# CONFIG_BLK_DEV_CARMEL is not set
 CONFIG_BLK_DEV_RAM=y
 CONFIG_BLK_DEV_RAM_SIZE=4096
 CONFIG_BLK_DEV_INITRD=y
@@ -1963,11 +2043,11 @@
 # CONFIG_BLK_DEV_IDEDMA_FORCED is not set
 CONFIG_IDEDMA_PCI_AUTO=y
 # CONFIG_IDEDMA_ONLYDISK is not set
-# CONFIG_IDEDMA_PCI_WIP is not set
 CONFIG_BLK_DEV_ADMA=y
 # CONFIG_BLK_DEV_AEC62XX is not set
 # CONFIG_BLK_DEV_ALI15X3 is not set
 # CONFIG_BLK_DEV_AMD74XX is not set
+# CONFIG_BLK_DEV_ATIIXP is not set
 # CONFIG_BLK_DEV_CMD64X is not set
 # CONFIG_BLK_DEV_TRIFLEX is not set
 # CONFIG_BLK_DEV_CY82C693 is not set
@@ -1990,7 +2070,6 @@
 CONFIG_BLK_DEV_IDEDMA=y
 # CONFIG_IDEDMA_IVB is not set
 CONFIG_IDEDMA_AUTO=y
-# CONFIG_DMA_NONPCI is not set
 # CONFIG_BLK_DEV_HD is not set
 
 #
@@ -2017,6 +2096,12 @@
 # CONFIG_SCSI_LOGGING is not set
 
 #
+# SCSI Transport Attributes
+#
+# CONFIG_SCSI_SPI_ATTRS is not set
+# CONFIG_SCSI_FC_ATTRS is not set
+
+#
 # SCSI low-level drivers
 #
 # CONFIG_BLK_DEV_3W_XXXX_RAID is not set
@@ -2052,10 +2137,13 @@
 # CONFIG_SCSI_QLOGIC_ISP is not set
 # CONFIG_SCSI_QLOGIC_FC is not set
 # CONFIG_SCSI_QLOGIC_1280 is not set
-CONFIG_SCSI_QLA2XXX_CONFIG=y
+CONFIG_SCSI_QLA2XXX=y
 # CONFIG_SCSI_QLA21XX is not set
 # CONFIG_SCSI_QLA22XX is not set
-# CONFIG_SCSI_QLA23XX is not set
+# CONFIG_SCSI_QLA2300 is not set
+# CONFIG_SCSI_QLA2322 is not set
+# CONFIG_SCSI_QLA6312 is not set
+# CONFIG_SCSI_QLA6322 is not set
 # CONFIG_SCSI_SYM53C416 is not set
 # CONFIG_SCSI_DC395x is not set
 # CONFIG_SCSI_DC390T is not set
@@ -2076,7 +2164,7 @@
 CONFIG_MD=y
 # CONFIG_BLK_DEV_MD is not set
 CONFIG_BLK_DEV_DM=y
-CONFIG_DM_IOCTL_V4=y
+# CONFIG_DM_CRYPT is not set
 
 #
 # Fusion MPT device support
@@ -2084,7 +2172,7 @@
 # CONFIG_FUSION is not set
 
 #
-# IEEE 1394 (FireWire) support (EXPERIMENTAL)
+# IEEE 1394 (FireWire) support
 #
 # CONFIG_IEEE1394 is not set
 
@@ -2113,7 +2201,6 @@
 # CONFIG_NET_IPIP is not set
 # CONFIG_NET_IPGRE is not set
 # CONFIG_ARPD is not set
-# CONFIG_INET_ECN is not set
 # CONFIG_SYN_COOKIES is not set
 # CONFIG_INET_AH is not set
 # CONFIG_INET_ESP is not set
@@ -2126,7 +2213,6 @@
 #
 # SCTP Configuration (EXPERIMENTAL)
 #
-CONFIG_IPV6_SCTP__=y
 # CONFIG_IP_SCTP is not set
 # CONFIG_ATM is not set
 # CONFIG_VLAN_8021Q is not set
@@ -2190,6 +2276,7 @@
 CONFIG_TULIP=y
 # CONFIG_TULIP_MWI is not set
 # CONFIG_TULIP_MMIO is not set
+# CONFIG_TULIP_NAPI is not set
 CONFIG_DE4X5=y
 CONFIG_WINBOND_840=y
 CONFIG_DM9102=y
@@ -2220,6 +2307,7 @@
 # CONFIG_8139TOO_TUNE_TWISTER is not set
 # CONFIG_8139TOO_8129 is not set
 # CONFIG_8139_OLD_RX_RESET is not set
+CONFIG_8139_RXBUF_IDX=1
 CONFIG_SIS900=y
 CONFIG_EPIC100=y
 CONFIG_SUNDANCE=y
@@ -2264,6 +2352,7 @@
 # CONFIG_NET_FC is not set
 # CONFIG_RCPCI is not set
 # CONFIG_SHAPER is not set
+# CONFIG_NETCONSOLE is not set
 
 #
 # Wan interfaces
@@ -2284,11 +2373,13 @@
 # Bluetooth support
 #
 # CONFIG_BT is not set
+# CONFIG_NETPOLL is not set
+# CONFIG_NET_POLL_CONTROLLER is not set
 
 #
 # ISDN subsystem
 #
-# CONFIG_ISDN_BOOL is not set
+# CONFIG_ISDN is not set
 
 #
 # Telephony Support
@@ -2326,6 +2417,7 @@
 CONFIG_INPUT_KEYBOARD=y
 CONFIG_KEYBOARD_ATKBD=y
 # CONFIG_KEYBOARD_SUNKBD is not set
+# CONFIG_KEYBOARD_LKKBD is not set
 # CONFIG_KEYBOARD_XTKBD is not set
 # CONFIG_KEYBOARD_NEWTON is not set
 # CONFIG_INPUT_MOUSE is not set
@@ -2350,12 +2442,8 @@
 # Non-8250 serial port support
 #
 CONFIG_UNIX98_PTYS=y
-CONFIG_UNIX98_PTY_COUNT=64
-
-#
-# Mice
-#
-# CONFIG_BUSMOUSE is not set
+CONFIG_LEGACY_PTYS=y
+CONFIG_LEGACY_PTY_COUNT=256
 # CONFIG_QIC02_TAPE is not set
 
 #
@@ -2392,6 +2480,11 @@
 # CONFIG_I2C is not set
 
 #
+# Misc devices
+#
+# CONFIG_IBM_ASM is not set
+
+#
 # Multimedia devices
 #
 # CONFIG_VIDEO_DEV is not set
@@ -2405,7 +2498,7 @@
 # Graphics support
 #
 # CONFIG_FB is not set
-# CONFIG_VIDEO_SELECT is not set
+CONFIG_VIDEO_SELECT=y
 
 #
 # Console display driver support
@@ -2465,7 +2558,6 @@
 CONFIG_PROC_FS=y
 CONFIG_PROC_KCORE=y
 # CONFIG_DEVFS_FS is not set
-CONFIG_DEVPTS_FS=y
 # CONFIG_DEVPTS_FS_XATTR is not set
 CONFIG_TMPFS=y
 # CONFIG_HUGETLBFS is not set
@@ -2478,6 +2570,7 @@
 # CONFIG_ADFS_FS is not set
 # CONFIG_AFFS_FS is not set
 # CONFIG_HFS_FS is not set
+# CONFIG_HFSPLUS_FS is not set
 # CONFIG_BEFS_FS is not set
 # CONFIG_BFS_FS is not set
 # CONFIG_EFS_FS is not set
@@ -2559,6 +2652,7 @@
 # Kernel hacking
 #
 # CONFIG_DEBUG_KERNEL is not set
+CONFIG_EARLY_PRINTK=y
 # CONFIG_DEBUG_SPINLOCK_SLEEP is not set
 # CONFIG_FRAME_POINTER is not set